USE tempdb;
GO

CREATE TABLE Clients 
(
	ClientGuid UNIQUEIDENTIFIER NULL DEFAULT NEWID(),
	FirstName NVARCHAR(30) NULL,
	LastName NVARCHAR(30) NULL
);
GO

INSERT INTO Clients (FirstName, LastName)
VALUES
	(N'Michael', N'Adams'),
	(N'Tom', N'Woods'),
	(N'Peter', N'Johnson');
GO

CREATE TABLE Names 
(
	Name NVARCHAR(30) NULL,
);
GO

INSERT INTO Names (Name)
VALUES
	(N'Michael'),
	(N'Peter');
GO

-- show data
SELECT * FROM Clients;
SELECT * FROM Names;

-- matches
-- WHERE...IN
SELECT * 
FROM Clients
WHERE FirstName IN (
	SELECT Name
	FROM Names
	);
GO
-- EXISTS
SELECT * 
FROM Clients c
WHERE EXISTS (
	SELECT 1
	FROM Names n
	WHERE c.FirstName = n.Name
	);
GO

-- mismatches
-- NOT IN
SELECT * 
FROM Clients
WHERE FirstName NOT IN (
	SELECT Name
	FROM Names
	);
GO
-- NOT EXISTS
SELECT * 
FROM Clients c
WHERE NOT EXISTS (
	SELECT 1
	FROM Names n
	WHERE c.FirstName = n.Name
	);
GO

-- insert NULL value into Clients table
INSERT INTO Clients (FirstName, LastName)
VALUES (NULL, N'Adams');
GO

-- NOT IN with NULL check
SELECT * 
FROM Clients
WHERE FirstName NOT IN (
	SELECT Name
	FROM Names
	)
	OR FirstName IS NULL;
GO
